> ## Documentation Index
> Fetch the complete documentation index at: https://developer.lemlist.com/llms.txt
> Use this file to discover all available pages before exploring further.

> Adds new custom variables to a lead.

# Add Custom Variables on Leads

To add custom fields, you can add as many as you want in the body of your request with the desired value for these **new** fields.

<Warning>
  The purpose of this endpoint is first and foremost to create new variables, even though we have to give them specific values on a specific lead. That's why you'll get errors if you give variable names that already exist on a lead.

  By default, lemlist includes several variables related to leads: `email`, `firstName`, `lastName`, `picture`, `phone`, `linkedinUrl`, `companyName`, `companyDomain`, and `icebreaker`.

  Beware, you **cannot** add a new variable with the same name as an existing variable (default or custom).
</Warning>


## OpenAPI

````yaml post /leads/{leadId}/variables
openapi: 3.0.0
info:
  title: lemlist API
  version: 1.0.0
  description: >-
    Welcome to the lemlist Developer Documentation.


    lemlist is very customizable and open. You'll find on this page all the API
    and integration you can do with lemlist.


    # Rate Limit


    lemlist's API rate limits requests in order to prevent abuse and overload of
    our services.  

    Rate limits are applied on all routes and per API key performing the
    request.  

    The rate limits are **20** requests per **2** seconds.  

    The response provides any information you may need about it:


    | Header | Description |

    | --- | --- |

    | Retry-After | The number of seconds in which you can retry |

    | X-RateLimit-Limit | The maximum requests in that time |

    | X-RateLimit-Remaining | The number of remaining requests you can make |

    | X-RateLimit-Reset | The date when the rate limit will reset |


    _Example of values for the rate limit headers_


    ``` json

    {
        "Retry-After": 2,
        "X-RateLimit-Limit": 20,
        "X-RateLimit-Remaining": 7,
        "X-RateLimit-Reset" : "Tue Feb 16 2021 09:02:42 GMT+0100 (Central European Standard Time)"
    }

     ```

    # Definitions


    ## Team


    A team is the entity of lemlist that can handle users and billing.


    ## Credits


    Credits are the coins a team uses to enrich emails, LinkedIn URLs, etc. via
    the enrich route. Each enrichment feature needs a certain amount of credits
    to run.


    ## User


    You use a user account to connect to lemlist and send messages via the
    connected emails or LinkedIn account.


    ## Campaign


    A campaign is the entity to automate outreach. A campaign has multiple
    sequences composed of steps.


    ## Lead


    A lead is a person that you try to contact via a campaign.


    ## Activity


    An activity is the history of all the steps.


    ## Unsubscribe


    An unsubscribe occurs when a person decides they don't want to receive
    emails from you anymore.


    # Authentication


    All API routes use the dedicated subdomain `api.lemlist.com`.


    lemlist uses API keys to allow access to the API. You can get your lemlist
    API key at our [integration
    page](https://app.lemlist.com/settings/integrations).


    You need to add the `Authorization` header using the `Basic` authentication
    type. `login:password` **where the login is always empty and the password is
    the API key**.


    ⚠️ **Don't forget to add the semicolon (**`:`**) before your API key in curl
    command.**


    > To authorize, use this code: 
      

    ``` shell

    curl https://api.lemlist.com/api/team \
      --user ":YourApiKey"

     ```

    **Make sure to replace** **`YourApiKey`** **with your API key.**


    # Give feedback


    If you want to report a bug, ask for data, or share with us a use case,
    please fill this [form](https://lemlist.typeform.com/to/mfVlkyGf). It will
    help us centralize your needs!
servers:
  - url: https://api.lemlist.com/api
security:
  - basicAuth: []
paths:
  /leads/{leadId}/variables:
    parameters:
      - name: leadId
        in: path
        required: true
        description: The unique identifier of the lead
        example: lea_8xJSc7sV7ggpiVnXe
        schema:
          type: string
    post:
      tags:
        - Leads
      summary: Add Custom Variables on Leads
      description: Add custom variables to a lead and sets values for that specific lead.
      parameters:
        - name: customField1
          in: query
          required: false
          description: Example custom variable
          example: Lemlist
          schema:
            type: string
        - name: customField2
          in: query
          required: false
          description: Example custom variable
          example: Will Rule
          schema:
            type: string
        - name: customField3
          in: query
          required: false
          description: Example custom variable
          example: The World
          schema:
            type: string
      responses:
        '200':
          description: Success
          content:
            application/json:
              schema:
                type: object
                additionalProperties: true
              example:
                ok: true
        '400':
          description: Bad team
          content:
            text/plain:
              example: Variable not found
        '401':
          description: Unauthorized
        '404':
          description: Lead not found
          content:
            text/plain:
              example: Lead not found
components:
  securitySchemes:
    basicAuth:
      type: http
      scheme: basic

````